unit Unit1;

interface

uses
  Windows, Messages, SysUtils, Variants, Classes, Graphics, Controls, Forms,
  Dialogs, Grids;

type
  TForm1 = class(TForm)
    dgDraw: TDrawGrid;
    procedure FormCreate(Sender: TObject);
    procedure FormDeactivate(Sender: TObject);
    procedure dgDrawGetEditText(Sender: TObject; ACol, ARow: Integer;
      var Value: String);
    procedure dgDrawSetEditText(Sender: TObject; ACol, ARow: Integer;
      const Value: String);
    procedure dgDrawDrawCell(Sender: TObject; ACol, ARow: Integer;
      Rect: TRect; State: TGridDrawState);
    procedure FormResize(Sender: TObject);
  private
    { Private declarations }
  slBitMap:TStringList;
  public
    { Public declarations }
  end;

var
  Form1: TForm1;

implementation

{$R *.dfm}

procedure TForm1.FormCreate(Sender: TObject);
const Bmp_Path='E:\Instal\Common Files\Borland Shared\'
         +'Images\Splash\16Color\';
       FNames: array [0..3] of string=
         ('ATHENA.bmp','CHIP.bmp','CONSTRUC.bmp','TECHNLGY.bmp');
var k:integer;
begin
  slBitMap := TStringList.Create;
  with slBitMap do for k:=0 to 3 do
   begin
    Add(FNames[k]);
    Objects[k]:=TBitMap.Create;
    (Objects[k] as TBitMap).LoadFromFile(Bmp_Path+FNames[k]);
   end;
end;

procedure TForm1.FormDeactivate(Sender: TObject);
begin
   slBitMap.Free;
end;

procedure TForm1.dgDrawGetEditText(Sender: TObject; ACol, ARow: Integer;
  var Value: String);
begin
 Value:= slBitMap[2*ACol + ARow];
end;

procedure TForm1.dgDrawSetEditText(Sender: TObject; ACol, ARow: Integer;
  const Value: String);
begin
 slBitMap[2*ACol + ARow]:= Value;
end;

procedure TForm1.dgDrawDrawCell(Sender: TObject; ACol, ARow: Integer;
  Rect: TRect; State: TGridDrawState);
var k: integer;
begin
   k:= 2*ACol + ARow;
 with dgDraw.Canvas, Rect, slBitMap do
 begin
   bottom:= bottom- TextHeight('1')-2;
   StretchDraw(Rect, (Objects[k] as TBitMap));
   TextOut(Left + (Right - Left - TextWidth(slBitMap[k])) div 2,
      Bottom + 1, slBitMap[k] );
 end;
end;


procedure TForm1.FormResize(Sender: TObject);
begin
 with dgDraw do
 begin
  DefaultColWidth:= ClientRect.Right div 2 - 1;
  DefaultRowHeight:= ClientRect.Bottom div 2 - 1;
 end;
end;

end.
